Bug 734245

Summary: Unexpected handling of x86_64 packages on i686 system
Product: [Fedora] Fedora Reporter: Mads Kiilerich <mads>
Component: rpmAssignee: Panu Matilainen <pmatilai>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 16CC: ffesti, jnovy, pmatilai
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-02-13 21:24:10 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Description Mads Kiilerich 2011-08-29 21:09:59 UTC
Multilib might be a hack, but sometimes it is the best solution. One example is when a 32-bit-only app has to run on a system that is booted from 64-bit EFI and thus requires a 64-bit kernel.

rpm and Fedora do support multilib on x86_64. That works fine. Packages with arch i686, x86_64 or noarch can be installed, and packages that only differs in arch can be installed side by side.

On x686 it isn't possible to install x86_64 packages because it is the wrong arch. Such packages can only be installed with --ignorearch. The arch will however no matter what be ignored when it decides if it is a new package or the package already is installed. The package can thus only be installed with --force and then it is installed as a reinstallation of an existing package and the old package isn't removed but just forgotten. The old package no longer appears in the list of installed packages but all files are left in the filesystem.

Example demonstrating the confusing and IMHO incorrect behaviour:

# rpm -q kernel
kernel-3.0.1-3.fc16.i686
# rpm -ihv kernel-3.0.1-3.fc16.x86_64.rpm
Preparing...                ########################################### [100%]
	package kernel-3.0.1-3.fc16.x86_64 is intended for a different architecture
	package kernel-3.0.1-3.fc16.x86_64 is already installed
# rpm -ihv kernel-3.0.1-3.fc16.x86_64.rpm --force
Preparing...                ########################################### [100%]
	package kernel-3.0.1-3.fc16.x86_64 is intended for a different architecture
# rpm -ihv ~dev/lars-mac/custom-rpms/kernel-3.0.1-3.fc16.x86_64.rpm --ignorearch
Preparing...                ########################################### [100%]
	package kernel-3.0.1-3.fc16.x86_64 is already installed
# rpm -ihv ~dev/lars-mac/custom-rpms/kernel-3.0.1-3.fc16.x86_64.rpm --ignorearch --force
Preparing...                ########################################### [100%]
   1:kernel                 ########################################### [100%]
# rpm -q kernel
kernel-3.0.1-3.fc16.x86_64
# ll /boot/vmlinuz-3.0.1-3.fc16.*
-rwxr-xr-x. 1 root root 4196096 Aug  8 20:47 /boot/vmlinuz-3.0.1-3.fc16.i686
-rwxr-xr-x. 1 root root 4234672 Aug  8 20:30 /boot/vmlinuz-3.0.1-3.fc16.x86_64
# rpm -qf /boot/vmlinuz-3.0.1-3.fc16.*
file /boot/vmlinuz-3.0.1-3.fc16.i686 is not owned by any package
kernel-3.0.1-3.fc16.x86_64
#

I would expect that arch always was considered a part of envra, even on non-multilib platforms. No matter what, I would expect that rpm kept track of which packages was installed on the system.

rpm-4.9.1.1-2.fc16.i686

Comment 1 Panu Matilainen 2011-10-14 09:56:21 UTC
With --ignorearch and --force type overrides, you essentially liberate rpm from the responsibility of keeping your system sane. What exactly happens with --ignorearch is pretty much undefined behavior.

Comment 2 Mads Kiilerich 2011-10-14 11:23:56 UTC
I agree that it isn't rpm's responsibility to keep the system sane after I have used options for doing crazy stuff.

I do however expect more than just undefined behaviour from rpm. I would expect consistent and "you got what you asked for" behaviour.

Comment 3 Fedora End Of Life 2013-01-16 17:02:42 UTC
This message is a reminder that Fedora 16 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 16. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '16'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 16's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 16 is end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" and open it against that version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 4 Fedora End Of Life 2013-02-13 21:24:13 UTC
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.